//
//  DetailViewController.m
//  KST1012_Demo
//
//  Created by bob on 3/26/13.
//  Copyright (c) 2013 bob. All rights reserved.
//

#import "DetailViewController.h"
#import "KSTBLEManager.h"

@interface DetailViewController ()
@end

@implementation DetailViewController

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        self.title = NSLocalizedString(@"Proximity Tag", @"Proximity Tag");
    }
    return self;
}

- (void)viewDidLoad
{
    [super viewDidLoad];
    [_proximityTag setDelegate:self];
    [_proximityTag establishConnection];
}

-(void) viewWillDisappear:(BOOL)animated {
    if ([self.navigationController.viewControllers indexOfObject:self]==NSNotFound) {
        // User has pressed the Back button.  Kill the connection.
        CBPeripheral *thisPeripheral = _proximityTag.peripheral;
        [[KSTBLEManager manager] KSTBLEManagerDisconnectedFromDevice:thisPeripheral];
    }
    [super viewWillDisappear:animated];
}

-(IBAction)immediateAlertChanged:(id)sender {
    
    if( _immediateAlertSegmentedControl.selectedSegmentIndex == 0 ) {
        [_proximityTag silenceProximityAlert];
        
    } else if( _immediateAlertSegmentedControl.selectedSegmentIndex == 1 ) {
        [_proximityTag soundProximityAlert];
    }
    
}

-(IBAction)linkLossAlertChanged:(id)sender {
    
    if( _linkLossAlertSegmentedControl.selectedSegmentIndex == 0 ) {
        [_proximityTag disableLinkLossAlert];
        
    } else if( _linkLossAlertSegmentedControl.selectedSegmentIndex == 1 ) {
        [_proximityTag enableLinkLossAlert];
    }
    
}

#pragma mark KST1012 Delegate Methods
-(void)receivedAlert {
    UIAlertView *incomingAlert = [[UIAlertView alloc] initWithTitle:@"KST1012 Demo" message:@"The button on the Proximity Tag was pressed." delegate:nil cancelButtonTitle:@"OK" otherButtonTitles:nil];
    [incomingAlert show];
}

-(void)updatedBatteryLevelTo:(KSTBLEBatteryLevel)newBatteryLevel {
    if( newBatteryLevel == KSTBLEBatteryLevel0_25 ) {
        [_battImageView setImage:[UIImage imageNamed:@"battery20.png"]];
        
    } else if( newBatteryLevel == KSTBLEBatteryLevel25_50 ) {
        [_battImageView setImage:[UIImage imageNamed:@"battery40.png"]];
        
    } else if( newBatteryLevel == KSTBLEBatteryLevel50_75 ) {
        [_battImageView setImage:[UIImage imageNamed:@"battery60.png"]];
        
    } else if( newBatteryLevel == KSTBLEBatteryLevel75_100 ) {
        [_battImageView setImage:[UIImage imageNamed:@"batteryFULL.png"]];
    }
    
}


- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}
				
@end
