//
//  KST1010.h
//  KST1010 - Bluetooth Low Energy Gumstick
//
//  Copyright (c) 2013 KS Technologies, LLC. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <CoreBluetooth/CoreBluetooth.h>

#import "KSTBLEManager.h"

// Delegate Methods
@protocol KST1010Delegate
- (void)receivedData:(NSData *)incomingData;
@end

@interface KST1010 : NSObject <CBPeripheralDelegate> {
    
@private
    CBPeripheral *_peripheral;
    
}

// Delegate
@property( nonatomic, strong ) id <KST1010Delegate> delegate;

// Properties
@property( nonatomic, readonly ) NSMutableDictionary *deviceInformation;
@property( nonatomic, readonly ) NSNumber *isConnected;                     // boolValue
@property( nonatomic, readonly ) KSTBLESignalStrength *signalStrength;
@property( nonatomic, readonly ) KSTBLEDeviceTypes *deviceType;             // KST1010_Gumstick

// Methods
-(void)writeData:(NSData *)outgoingData;

@end