//
//  MasterViewController.m
//  KST1012_Demo
//
//  Created by bob on 3/26/13.
//  Copyright (c) 2013 bob. All rights reserved.
//

#import "MasterViewController.h"
#import "DetailViewController.h"

#import "KSTBLEManager.h"
#import "KST1012.h"

@interface MasterViewController () {
}
@end

@implementation MasterViewController

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        self.title = NSLocalizedString(@"BLE Devices", @"BLE Devices");
    }
    return self;
}

- (void)viewDidLoad
{
    [super viewDidLoad];
    [[KSTBLEManager manager] KSTBLEManagerInitialize];
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(foundNewDevice:) name:kKSTBLEManagerDiscoveredNewDevice object:nil];
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(connectedToNewDevice:) name:kKSTBLEMAnagerConnectedToDevice object:nil];
    [[[KSTBLEManager manager] devicesToFind] addObject:[NSNumber numberWithInt:KST1012_ProximityTag]];
    [[KSTBLEManager manager] KSTBLEManagerStartScanForDevices];
}

-(void)viewDidAppear:(BOOL)animated {
    [super viewDidAppear:YES];
    [self.tableView reloadData];
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

-(void)foundNewDevice:(NSNotification *)aNotification {
    [self.tableView reloadData];
}

-(void)connectedToNewDevice:(NSNotification *)aNotification {
    
    NSDictionary *payloadDictionary = [aNotification userInfo];
    
    KST1012 *aProximityTag = [[KST1012 alloc] init];
    aProximityTag.peripheral = [payloadDictionary valueForKey:@"peripheral"];
    
    self.detailViewController.proximityTag = aProximityTag;
    
    [self.navigationController pushViewController:self.detailViewController animated:YES];
    
}

#pragma mark - Table View
- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
{
    return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    return [[[KSTBLEManager manager] visibleDevices] count];
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    static NSString *CellIdentifier = @"Cell";
    
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
    if (cell == nil) {
        cell = [[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:CellIdentifier];
        cell.accessoryType = UITableViewCellAccessoryDisclosureIndicator;
    }

    // Fetch the peripheral from the KSTBLEManager and show us the name of the device
    CBPeripheral *aPeripheral = [[[KSTBLEManager manager] visibleDevices] objectAtIndex:indexPath.row];
    cell.textLabel.text = [NSString stringWithFormat:@"%@", [aPeripheral name]];

    return cell;
}

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    if (!self.detailViewController) {
        self.detailViewController = [[DetailViewController alloc] initWithNibName:@"DetailViewController" bundle:nil];
    }

    CBPeripheral *aPeripheral = [[[KSTBLEManager manager] visibleDevices] objectAtIndex:indexPath.row];
    [[KSTBLEManager manager] KSTBLEManagerConnectToDevice:aPeripheral];
    
    // Notice that we do not descend to the detail view until we've connected
    
}

@end